from server.testserver import get_testdata, send_result


def median(values: list):
    """ Berechnet den Median zu einer Zahlenfolge """

    # Sortiere die Zahlen aufsteigend
    values.sort()
    length = len(values)

    # Der Index liegt genau in der Mitte der Zahlen
    index = (length - 1) // 2

    if length % 2:
        # Wenn die Zahlenfolge eine ungerade Länge hat, nimm den Wert in der Mitte
        return values[index]
    else:
        # Bei einer geraden Länge, nimm den Durchschnitt der mittleren beiden Werte
        return (values[index] + values[index + 1]) / 2


def test_median():
    """ Testet den Median gegen das IUL"""

    response = get_testdata("median")
    results = []

    for signal in response['signals']:
        # Hole die Parameter des Signals
        test_id = signal['id']
        values = signal['values']

        # Berechne den Median des Signals
        result = median(values)

        # Hänge das Ergebnis in der Liste an
        results.append({'id': test_id, 'median': result})

    # Sende die Ergebnis-Liste zurück an das IUL
    send_result('median', {'session': response['session'], 'results': results})


if __name__ == '__main__':
    test_median()
