import requests
import json
import sys
from config import Config as cfg


if len(sys.argv) >= 2:
    host = sys.argv[1]
else:
    host = cfg.host


def get_testdata(exercise_id):
    data_url = host + '/exercises/' + exercise_id + '/data'
    print(data_url)
    try:
        response = requests.get(data_url, headers={'Authorization': 'Token ' + cfg.token})
        if response.status_code != 200:
            print(response.text)
            print("Fehler bei get_exercise Serveranfrage - ungueltiger Token?")
            exit(1)
        json_response = json.loads(response.text)
    except Exception as inst:
        print("Fehler bei get_exercise Serveranfrage")
        print(inst)
        exit(1)
    return json_response


def send_result(exercise_id, data):
    result_url = host + '/exercises/' + exercise_id + '/result'
    response = requests.post(result_url, json=data, headers={'Authorization': 'Token ' + cfg.token, 'content-type': 'application/json'})
    response = json.loads(response.text)
    assert 'error' not in response, "Fehler bei send_results: " + response['error']
    return response
